/*
 * Copyright 2017-2018 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.verilog.parser.sample;

import java.nio.file.Paths;

/**
 * Test for "bug9165/test1_dispatcher.v" Verilog module.
 *
 * @author <a href="mailto:smolov@ispras.ru">Sergey Smolov</a>
 */
public class Bug9165Test1TestCase extends VerilogPrinterTestCase {

  @Override
  public String[] getOptions() {
    return new String[] { "--module-name", "test1_dispatcher" };
  }

  @Override
  public String[] getPaths() {
    return new String[] {
        Paths.get("bugs-tests", "bug9165", "test1_dispatcher.v").toString(),
        Paths.get("bugs-tests", "bug9165", "test2_buffers.v").toString(),
        Paths.get("bugs-tests", "bug9165", "test3_fifo.v").toString(),
        Paths.get("bugs-tests", "bug9165", "test4_dp_ram.v").toString()};
  }
}
