/*
 * Copyright 2018-2019 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.verilog.parser.sample;

import java.nio.file.Paths;

/**
 * Test for Altera's prefetcher (modified).
 *
 * @author <a href="mailto:kamkin@ispras.ru">Alexander Kamkin</a>
 */
public class PrefetcherTestCase extends VerilogPrinterTestCase {

  @Override
  public String[] getOptions() {
    return new String[] { "--module-name", "altera_msgdma_prefetcher" };
  }

  @Override
  public String[] getPaths() {
    return new String[] {
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altera_msgdma_prefetcher_csr.v").toString(),
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altera_msgdma_prefetcher_fifo.v").toString(),
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altera_msgdma_prefetcher_interrupt.v").toString(),
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altera_msgdma_prefetcher_read.v").toString(),
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altera_msgdma_prefetcher_write_back.v").toString(),
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altsyncram_model.v").toString(),
        Paths.get(
            "rest-tests",
            "altera_msgdma_mod",
            "prefetcher",
            "altera_msgdma_prefetcher.v").toString()
    };
  }
}
