module x(ix, ox);
  input ix;
  output ox;
  parameter px = 0;

  assign ox = px;
endmodule

module y(iy, oy);
  input iy;
  output oy;
  parameter py = 0;

  x xx(.ix(iy), .oy(oy));

  always @(posedge iy)
    begin
      oy <= py;
    end
endmodule

module z(iz, oz);
  input iz;
  output oz;
  parameter pz = 0;

  y yy(.iy(iz), .oy(oz));

  always @(posedge iz)
    begin
      oz <= pz;
    end
endmodule

module m(im, om1, om2, om3, om4);
  input im;
  output om1;
  output om2;
  output om3;
  output om4;

  parameter pm = 1;

  x            a(.ix(im), .ox(om1));
  y #(.py(1))  b(.iy(im), .oy(om2));
  z #(.pz(pm)) c(.iz(im), .oz(om3));

  always @(negedge im)
    begin
      om4 <= 1'bX;
    end

  defparam a.px = pm;
endmodule